global n h

% Solve the Poisson equation: laplace(phi) = 1 in the unit square
% (|x,y|<=1) with homogeneous boundary conditions: phi=0 on the
% boundary 

% Number of divisions along x and y
n=10;

h=1/n;
b=-ones((n-1)^2,1);

nmax=1000;
x=0*b;
omega=h^2/16;
rh=[];
for k=1:nmax
  r=b-laplacian(x);
  ar=sqrt(sum(r.*r));
  rh=[rh;ar];
  x=x+omega*r;
end

Phi=zeros(n+1);
Phi(2:n,2:n)=reshape(x,n-1,n-1);

% The maximum value attained at the center can be computed by
% separation of variables in the form of a closed sum and is
% approx. 0.073671 

max(max(-Phi))
